<template>
  <div>
    <Modal v-model="showEditModal" v-drag :mask-closable="true" width="1000px">
      <p slot="header">
        {{ modalTitle }}
      </p>
      <div>
        <Form
          id="right-edit-form-edit"
          ref="formObj"
          :model="formObj"
          :rules="ruleValidate"
          :label-width="80"
          inline
        >
          <Form-item label="内审员" prop="checkMemberName" class="width-48">
            <Select v-model="formObj.checkMemberId" :label-in-value="true" name="checkMemberName" filterable @on-change="_checkMemberNameChange">
              <Option v-for="item in userList" :key="item.id" :value="item.id">
                {{ item.name }}
              </Option>
            </Select>
          </Form-item>
          <Form-item label="内审结束日期" prop="checkManageTime" class="width-48">
            <Date-picker
              v-model="formObj.checkManageTime"
              name="checkManageTime"
              type="date"
              placeholder="请输入内审结束日期"
              format="yyyy-MM-dd"
              style="width: 100%;"
            />
          </Form-item>
          <Form-item label="质量管理体系" prop="checkManageItem" class="width-48">
            <Input
              v-model="formObj.checkManageItem"
              name="checkManageItem"
              placeholder="请输入质量管理体系"
            /></Input>
          </Form-item>
          <Form-item label="检查内容" prop="checkManageContent" class="width-48">
            <Tooltip content="长度为0-100" placement="bottom-start">
              <Input v-model="formObj.checkManageContent" name="checkManageContent" placeholder="请输入检查内容" style="width: 375px;" :maxlength="100" /></Input>
            </Tooltip>
          </Form-item>
          <Form-item label="审核类型" prop="checkType" class="width-48">
            <Select v-model="formObj.checkType" clearable style="width:100%" name="checkType">
              <Option v-for="item in innerAuditList" :key="item.name" :value="item.name">
                {{ item.name }}
              </Option>
            </Select>
          </Form-item>
          <Form-item label="检查结果" prop="checkManageResult" class="width-48">
            <Tooltip content="只能输入中文且长度为0-10" placement="bottom-start">
              <Input v-model="formObj.checkManageResult" name="checkManageResult" style="width: 375px" placeholder="请输入检查结果" :maxlength="10" /></Input>
            </Tooltip>
          </Form-item>
          <Form-item label="备注" prop="remark" class="width-48">
            <Tooltip content="长度为0-100" placement="bottom-start">
              <Input v-model="formObj.remark" name="remark" style="width: 375px;" placeholder="请输入备注" :maxlength="100" /></Input>
            </Tooltip>
          </Form-item>
        </Form>
      </div>
      <div slot="footer">
        <modal-footer ref="footerModal" :footer="footerList" @on-result-change="_footerResult" />
      </div>
    </Modal>

    <!--选择人员-->
    <UserInfo ref="userModal" is-change @on-result-change="_userData" />
  </div>
</template>
<script>
/**
 * 添加编辑
 */
import { dict, staffInfo, internalAuditManage } from '../../../api'
import global from '../../../api/config'
import UserInfo from '../../../components/user-info-single/assignPerson'
export default {
  components: { UserInfo },
  data: function() {
    return {
      id: '',
      modalTitle: '添加',
      formObj: {
        checkPlanId: undefined,
        checkMemberId: undefined,
        checkMemberName: undefined,
        checkManageTime: undefined,
        checkManageItem: undefined,
        checkManageContent: undefined,
        checkManageResult: undefined,
        remark: undefined,
        checkType: undefined,
        lmsFrameFileList: []
      },
      innerAuditList: [],
      userList: [],
      ruleValidate: {
        trainTopic: [
          { required: true, message: '培训主题不能为空', trigger: 'blur' }
        ],
        trainId: [
          { required: true, message: '所属培训计划不能为空', trigger: 'change' }
        ]
      },
      showEditModal: false,
      footerList: [
        { id: '', name: '取消', type: '' },
        { id: '', name: '确定', type: 'primary' }
      ]
    }
  },
  methods: {
    // modal
    _footerResult(name) {
      switch (name) {
        case '取消':
          this._cancel()
          break
        case '确定':
          this._ok()
          break
      }
    },
    _hideLoading() {
      this.$refs.footerModal._hideLoading()
    },
    _resultChange(result, msg) {
      if (result) {
        this.showEditModal = false
        this.$Message.success(msg)
        this.$emit('on-result-change')
      }
      this._hideLoading()
    },
    _userData(data, msg) {
      // 选择人员返回数据
      if (msg === 'applyName') {
        // 选择取样人取样人
        this.formObj.applyName = data.realname
        this.formObj.applyId = data.userId
      }
    },
    _getInnerAuditList: async function() {
      const result = await dict.getItem('内审审核类型')
      this.innerAuditList = result
    },
    _selectPlan() {
      this.$refs.trainPlanModal._open()
    },

    _backTrainPlanData(data) {
      this.formObj.trainPlan = data.name
      this.formObj.trainId = data.id
    },
    _ok() {
      this.$refs.formObj.validate(valid => {
        if (valid) {
          this._save(this.formObj)
        } else {
          this.$Message.error('表单验证失败')
          this._hideLoading()
        }
      })
    },

    _checkMemberNameChange(data) {
      this.formObj.checkMemberName = data.label.trim()
      this.formObj.checkMemberId = data.value.trim()
    },
    // 添加、编辑保存
    _save: async function(data) {
      if (data.id === undefined || data.id === '') {
        const result = await internalAuditManage.add(data)
        this._resultChange(result, '添加成功')
      } else {
        const result = await internalAuditManage.edit({
          id: data.id,
          obj: data
        })
        this._resultChange(result, '编辑成功')
      }
    },
    _cancel() {
      this.showEditModal = false
    },
    _getUserList: async function() {
      const result = await staffInfo.list({ status: 1 })
      if (result) {
        this.userList = result
      }
    },
    _leaderChange(obj) {
      console.log(obj)
      if (obj) {
        this.formObj.checkGroupLeaderName = obj.label.trim()
      } else {
        this.formObj.checkGroupLeaderName = ''
      }
    },

    _selectApply() {
      this.$refs.userModal._open('applyName')
    },
    _memberChange(obj) {
      let names = ''
      let ids = ''
      obj.forEach(function(item) {
        names = names + item.label.trim() + ','
        ids = ids + item.value + ','
      })
      this.formObj.checkGroupMemberNames = names.substring(0, names.length - 1)
      this.formObj.checkGroupMemberIds = ids.substring(0, ids.length - 1)
    },
    _open(checkPlanId, formObj) {
      const user = global.getUserInfo()
      console.log('----user-----', user)
      this.$refs.formObj.resetFields()
      this.formObj.checkPlanId = checkPlanId
      this.showEditModal = true
      this._hideLoading()
      this._getInnerAuditList()
      this._getUserList()
      if (formObj === '') {
        this.id = ''
        this.modalTitle = '添加内审实施管理'
      } else {
        this.id = formObj.id
        this.formObj = formObj
        this.modalTitle = '编辑内审实施管理'
        if (undefined !== formObj.checkManageTime) {
          this.formObj.checkManageTime = this.$dateformat(
            new Date(formObj.checkManageTime),
            'yyyy-mm-dd'
          )
        } else {
          this.formObj.checkManageTime = ''
        }
        if (undefined !== formObj.ctime) {
          this.formObj.ctime = this.$dateformat(
            new Date(formObj.ctime),
            'yyyy-mm-dd'
          )
        } else {
          this.formObj.ctime = ''
        }
      }
    }
  }
}
</script>
